<?php

declare(strict_types=1);

namespace App\Policies;

use App\Models\Feed;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class FeedPolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:Feed');
    }

    public function view(AuthUser $authUser, Feed $feed): bool
    {
        return $authUser->can('View:Feed');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:Feed');
    }

    public function update(AuthUser $authUser, Feed $feed): bool
    {
        return $authUser->can('Update:Feed');
    }

    public function delete(AuthUser $authUser, Feed $feed): bool
    {
        return $authUser->can('Delete:Feed');
    }

    public function restore(AuthUser $authUser, Feed $feed): bool
    {
        return $authUser->can('Restore:Feed');
    }

    public function forceDelete(AuthUser $authUser, Feed $feed): bool
    {
        return $authUser->can('ForceDelete:Feed');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:Feed');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:Feed');
    }

    public function replicate(AuthUser $authUser, Feed $feed): bool
    {
        return $authUser->can('Replicate:Feed');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:Feed');
    }
}
